Viewing Issue Advanced Details
ID Category [?] Severity [?] Reproducibility Date Submitted Last Update
07038 Sound Minor Always Jul 5, 2018, 17:17 Feb 29, 2020, 23:51
Tester Chris Hutt View Status Public Platform MAME (Official Binary)
Assigned To cmonkey Resolution Fixed OS Windows 10 (64-bit)
Status [?] Resolved Driver segahang.cpp
Version 0.199 Fixed in Version 0.220 Build 64-bit
Summary 07038: sharrier: High score entry music does not stop when end of entry
Description Music continues on return to title screen after high score initial entry end is selected on MAME. On real Space Harrier hardware the music stops at this point. Tested with full motion machine. Asked owner of a full motion and non moving cab, one of which has B ROM set and they see the same behavior of the music stopping on their machines too
Steps To Reproduce
Additional Information
Flags Verified with Original
Regression Version
Affected Sets / Systems sharrier
Attached Files
 
Relationships
There are no relationship linked to this issue.
Notes
5
User avatar
No.15242
Tafoid
Administrator
Jul 5, 2018, 17:58
PCB recording showing initial entry with music that stops (about 3:55 in)
User avatar
No.15243
StHiryu
Tester
Jul 5, 2018, 19:22
Looks like the Altered Beast transformation scene bug, when the music didn't stop. A bug fixed in recently mame versions.
User avatar
No.15245
Haze
Senior Tester
Jul 6, 2018, 16:08
could be a protection task, I guess, if so it's one of those cases where an MCU decap will come in handy.
User avatar
No.17443
cmonkey
Tester
Feb 29, 2020, 13:29
edited on: Feb 29, 2020, 13:34
This issue also affects Enduro Racer, assuming the machine is not set to free play mode and there are no credits in the machine when the game ends and you've entered your initials on the high score table. This can be seen clearly be seen at the 2 minute mark in this video from retroclinic :-



This issue would also affect Hang-On except for the fact that Hang-On is the only game in the driver which plays a main menu tune, which automatically overrides the high score initial entry tune. Enduro Racer does play a main menu tune, but only when the game is in free play mode or a credit is inserted.

The Space Harrier schematics show a connection between pin 23 (D5 of port B of the PPI @ IC121and the Z80 reset pin, via the LS244 @ 12C on the sound board. This connection is absent in the driver. The Hang-On schematics show that pin 23 of the PPI @ 4B is not connected, but they're wrong. I've personally asked a couple of friends, one of which who owns a Space Harrier board set and the other which owns a Hang-On board set, to test connectivity from D5 of the port B of the main PPI to the Z80 reset line, via the LS244 @ 12C on the sound board and they've both confirmed that the connectivity exists on their respective boards. Additionally the Z80 reset line was seen to briefly toggle at the end of the high score initial entry process on the Hang-On board set, when observed with a logic probe.

Setting and clearing D5 of port B of the main PPI should reset the Z80 audio sub-system in all games in the segahang driver.

A suggested fix is to add the following at line 68 :-

    // bit 5: Z80 RESET line
    m_soundcpu->set_input_line(INPUT_LINE_RESET, (data & 0x20) ? CLEAR_LINE : ASSERT_LINE);

I've done this edit to my driver and recompiled (using MAME 0.214 but I'm not aware of any reason why this would not work on the very latest version) and now all games in the driver reset the Z80 at the end of the high score initial entry process.

Big thanks go out to smarty and dj_yt on UKVAC for doing the necessary hardware testing for this fix.
User avatar
No.17444
hap
Developer
Feb 29, 2020, 23:51
Thanks, great work on the hardware verifications.